#ifndef MV1REGS
#define MV1REGS

#include <linux/wait.h>


#define NUM_LUTS 8
#define EVENT_TAB_SIZE (sizeof(u_char)<<8)

/*	MV-1000 Board Registers 	*/
#define H_V_START		0x30L
	#define RAM_MASK_MASK             (1L << 0)   //
	#define RAM_MASK_OFFSET           0   	//
	#define VIDEO_MASK_MASK           (1L << 1)   //
	#define VIDEO_MASK_OFFSET         1  
	#define MASTER_LOOP_MASK          (1L << 26)  // 
	#define MASTER_LOOP_OFFSET        26 
	#define H_PRESCALE_4_MASK         (1L << 27)  //
	#define H_PRESCALE_4_OFFSET       27
	#define MSTR_WAIT_FRAME_MASK      (1L << 28)  //
	#define MSTR_WAIT_FRAME_OFFSET    28
	#define H_PRESCALE_2_MASK         (1L << 29)  // 
	#define H_PRESCALE_2_OFFSET       29 
	#define MASTER_GO_MASK            (1L << 31)  // 
	#define MASTER_GO_OFFSET          31 

#define H_V_END		0x180000L

#define CURR_LINE		0x180000L
	#define SERIAL_DATA_IN_MASK       (1L << 27)  //
	#define SERIAL_DATA_IN_OFFSET     27
	#define TOP_CTL1_MASK             (1L << 30)  // pixmux3
	#define TOP_CTL1_OFFSET           30
	#define PIX_MUX4_MASK             (1L << 31)  // new field
	#define PIX_MUX4_OFFSET           31


#define GRAB_START_ADDR	0x140L

#define MISC_CONTROL		0x90L

	#define MISC_BITS_UNUSED     0x0000790CL

	#define PIX_MUX5_MASK             (1L << 0)   // new general purpose bit
	#define PIX_MUX5_OFFSET           0
	#define V_SCALE_2_MASK            (1L << 4)   // was in capture control reg
	#define V_SCALE_2_OFFSET          4   
	#define V_SCALE_4_MASK            (1L << 5)   // was in capture control reg
	#define V_SCALE_4_OFFSET          5
	#define CAPT_IDLE_MASK            (1L << 6)   // RO
	#define CAPT_IDLE_OFFSET          6
	#define ONE_GRABBED_MASK          (1L << 7)   // RO
	#define ONE_GRABBED_OFFSET        7
	#define OFF_END_MEM_MASK          (1L << 9)   // RO
	#define OFF_END_MEM_OFFSET        9
	#define TRIGGER_WAIT_MASK         (1L << 10)  // RO
	#define TRIGGER_WAIT_OFFSET       10
	#define LIST_TOP_LO_MASK          (1L << 16)  // Start of SDC in videomemory
	#define LIST_TOP_LO_OFFSET        16
	#define LIST_TOP_HI_MASK          (1L << 17)  // for master Transfer
	#define LIST_TOP_HI_OFFSET        17
	#define FIELD_STATE_MASK          (1L << 18)  // RO
	#define FIELD_STATE_OFFSET        18
	#define EXTERN_TRIGGER_MASK       (1L << 19)  // was in capture control reg
	#define EXTERN_TRIGGER_OFFSET     19
	#define VSY_SELF_MASK             (1L << 20)  // was in capture control reg
	#define VSY_SELF_OFFSET           20
	#define VRAM_SIZE_MASK            (1L << 21)  // was in capture control reg
	#define VRAM_SIZE_OFFSET          21
	#define TRIGGER_POLARITY_MASK     (1L << 22)  // was in capture control reg
	#define TRIGGER_POLARITY_OFFSET   22
	#define VSY_SOURCE_MASK           (1L << 23)  // was in capture control reg
	#define VSY_SOURCE_OFFSET         23
	#define MSTR_INT_ENA_MASK         (1L << 24)
	#define MSTR_INT_ENA_OFFSET       24
	#define MSTR_BAD_LIST_R_MASK      (1L << 24)  // RO. new field
	#define MSTR_BAD_LIST_R_OFFSET    24
	#define VID_INT_ENA_MASK          (1L << 25)
	#define VID_INT_ENA_OFFSET        25
	#define MSTR_INT_PND_R_MASK       (1L << 25)  // RO. write to capt. ctl reg.
	#define MSTR_INT_PND_R_OFFSET     25
	#define EXT_TRIGGER_IN_MASK       (1L << 27)  // RO
	#define EXT_TRIGGER_IN_OFFSET     27
	#define VID_INT_PND_R_MASK        (1L << 28)  // RO. write to capt. ctl reg.
	#define VID_INT_PND_R_OFFSET      28
	#define VSYNC_STATE_MASK          (1L << 31)
	#define VSYNC_STATE_OFFSET        31

#define LUT_ADDR_MASK	        0x808L
#define LUT_DATA		0x804L
#define VIDEO_CONTROL	 	0x180L

	#define  GENERAL_1_MASK           (1L << 1)
	#define  GENERAL_1_OFFSET         1
	#define  GENERAL_0_MASK           (1L << 13)
	#define  GENERAL_0_OFFSET         13
	#define  SINGLE_FRAME_MASK        (1L << 14)
	#define  SINGLE_FRAME_OFFSET      14
	#define  CAPTURE_ENABLE_MASK      (1L << 15)
	#define  CAPTURE_ENABLE_OFFSET    15
	#define  EVEN_START_MASK          (1L << 16)
	#define  EVEN_START_OFFSET        16
	#define  ODD_START_MASK           (1L << 17)
	#define  ODD_START_OFFSET         17
	#define  MEM_WRAP_MASK            (1L << 18)
	#define  MEM_WRAP_OFFSET          18
	#define  INTERLACE_MASK           (1L << 19)
	#define  INTERLACE_OFFSET         19
	#define  TOP_SC_EN_MASK           (1L << 21)      // MV1000 or MV1100 shift control
	#define  TOP_SC_EN_OFFSET	     21
	#define  TOP_CTL0_MASK            (1L << 22)      // was in misc reg
	#define  TOP_CTL0_OFFSET          22
	#define  MSTR_INT_PND_MASK        (1L << 24)      // 
	#define  MSTR_INT_PND_OFFSET      24 
	#define  MSTR_BAD_LIST_MASK       (1L << 25)      // 
	#define  MSTR_BAD_LIST_OFFSET     25 
	#define  CLAMP_ON_SYNC_MASK       (1L << 26)
	#define  CLAMP_ON_SYNC_OFFSET     26
	#define  CLAMP_ON_BPORCH_MASK     (1L << 27)
	#define  CLAMP_ON_BPORCH_OFFSET   27
	#define  VID_INT_PND_MASK         (1L << 28)      // WO. read from misc reg.
	#define  VID_INT_PND_OFFSET       28
	#define  X_H_SYNC_MASK            (1L << 29)
	#define  X_H_SYNC_OFFSET          29
	#define  EQ_REMOVE_MASK           (1L << 30)
	#define  EQ_REMOVE_OFFSET         30
	#define  FIELD_SRC_MASK           (1L << 31)
	#define  FIELD_SRC_OFFSET         31

	#define  ALL_INTERRUPTS_MASK_R	( (1<<24) + (1<<25) + (1<<28) )
	#define  ALL_INTERRUPTS_MASK_W	( (1<<24) + (1<<25) + (1<<28) )

#define EXTERN_DATA		0x300000
#define PB_BUS			0x820

/* Registers on PB-Bus */
#define LUT_CTL_ADR			( 1<< (16-16) )
	
	#define LUT_DIVIDE_4	(0x0040)
	#define LUT_VREG_OE_N	(0x0f00)
	#define LUT_D2PX_N	(0x8000) // 1 = 2 Bytes per pixelclock 0 = 1 Byte 

#define I2C_CTL_ADR		( 1<< (31-16) )
#define LM1882_ADR		( 1<< (24-16) )
#define LM1882_LOAD		LM1882_ADR	// connected to LOAD of LM1882

	// PB 8 is connected to ADDR/DATA and PB 9 is connected to L/HBYTE 
	#define  LM1882_ADDR          0X0000         
	#define  LM1882_L_BYTE        0X0100         
	#define  LM1882_H_BYTE        0X0300  
	#define  LM1882_AD_DATA       0x0100
	#define  LM1882_LH_BYTE       0x0200

#define LM1882_CSYNC  	0
#define LM1882_HVSYNC   1

#define LM1882_NO_EQSERR			0
#define LM1882_DOUBLE_INTERLACED_EQSERR		1
#define LM1882_DOUBLE_NI_EQSERR			2
#define LM1882_SINGLE_NI_EQSERR			3


/* Serial controlled */
#define DAC_CS				( 2<< (24-16) )
#define FILTER_CS			( 3<< (24-16) )
#define CK1522_CS			( 4<< (24-16) )
#define VCTL_REG		        ( 6<< (24-16) )
	#define SHIFT_DOWN_2_MASK	( 1 << 7 )
#define SERIAL_SPR		( 7<< (24-16) )

#define SERIAL_DATA		1
#define SERIAL_CLOCK		2

/* 	BT254 ADC 	*/

#define	BT254_COMMAND				0
	#define	BT254_SYNC_LEVEL		0
	#define BT254_COLOR_OUT_MASK		(3<<2);
	#define BT254_COLOR_OUT_OFFSET		2
		#define	BT254_TRUE_COLOR_24 	0	
		#define	BT254_TRUE_COLOR_15 	1	
		#define	BT254_TRUE_COLOR_8 	2	
		#define	BT254_PSEUDO_COLOR_8 	3	

	#define BT254_SYNC_SOURCE_MASK		(7<<4);
	#define BT254_SYNC_SOURCE_OFFSE		4
	#define	BT254_DIGITIZE_SELECT		7
	
		
#define BT254_IOUT0	1
#define BT254_IOUT1	2
#define BT254_IOUT2	3
#define BT254_IOUT3	4
#define BT254_IOUT4	5
#define BT254_IOUT5	6

/*	DAC-Selection 	*/
#define DAC0	0x0 	//	Phase Trim for ICS-1522
#define DAC1	0x1	// 	AD-Top
#define DAC2	0x2	//	AD-Bottom
#define DAC3	0x3	//	Video-Clamp Level
#define DAC4	0x4
#define DAC5	0x5

	#define  OEM_JMP15  (1 << 15)       /* Reserved for OEM use */
	#define  OEM_JMP14  (1 << 14)       /* Reserved for OEM use */
	#define  CFG_JMP13  (1 << 13)       /* Reserved for OEM use */
	#define  CFG_JMP12  (1 << 12)       /* JP23 */
	#define  CFG_JMP11  (1 << 11)       /* JP22 */
	#define  CFG_JMP10  (1 << 10)       /* JP21 */
	#define  MEM_SIZE   (1 << 9)        /* 1 = 1 Mbyte 0 = 4  mbyte */
	#define  ADC_TYPE   (1 << 8)        /* 1 = 8 bit   0 = 10      */

/* Digital ( daughter card) config jumper. */
/* if no card all will read '1', if daughter card with not data */
/* register all will read '0' */

	#define  DIG_CFG_JMP7    ( 1 << 7 )       /* */
	#define  DIG_CFG_JMP6    ( 1 << 6 )       /* */
	#define  DIG_NO_1100     ( 3 << 4 )       /* 00 - MV-1100 presents */
       		                                  /* 11 - no MV-1100       */
	#define  DIG_CFG_JMP3    ( 1 << 3 )       /* */
	#define  DIG_CFG_JMP2    ( 1 << 2 )       /* */
	#define  DIG_CFG_JMP1    ( 1 << 1 )       /* */
	#define  DIG_CFG_JMP0    ( 1 << 0 )       /* */


#define MV1100_COUNTER_OFFSET       0           // 1st byte
#define MV1100_COUNTER_MASK         0x0000FFL
#define MV1100_CLOCK_SELECT_OFFSET  8           // B0, B2 of 2nd byte
#define MV1100_CLOCK_SELECT_MASK    0x000300L   // 00: LDV
                                                // 01: inv. LDV
                                                // 10: H.D.
                                                // 11: V.D.
#define MV1100_EXT_TRIG_POL_OFFSET  10          // B2 of 2nd byte
#define MV1100_EXT_TRIG_POL_MASK    0x000400L   // 0: falling edge
                                                // 1: raising edge
#define MV1100_EXT_TRIG_OFFSET      11          // B3 of 2nd byte
#define MV1100_EXT_TRIG_MASK        0x000800L   // 0: software trigger
                                                // 1: ext. trigger
#define MV1100_MC1orINTEG_OFFSET    12          // B4 0f 2nd byte
#define MV1100_MC1orINTEG_MASK      0x001000L   // 0: output INTEG
                                                // 1: output MC1
#define MV1100_MODE_CONTROL_OFFSET  13
#define MV1100_MODE_CONTROL_MASK    0x182000L   // MC1: B5 of 2nd byte
                                                // MC0: B3 of 3rd byte
                                                // MC2: B4 of 3rd byte
#define MV1100_PAR_FRAME_REM_OFFSET 15          // B7 of 2nd byte
#define MV1100_PAR_FRAME_REM_MASK   0x008000L   // 0: no partial frame remove
                                                // 1: enable part. frame rem.
#define MV1100_PULSE_MODE_OFFSET    16
#define MV1100_PULSE_MODE_MASK      0x010000L   // 0: generate 1 pulse
                                                // 1: generate 2 pulses
#define MV1100_BYPASS_COUNTER_OFFSET 17
#define MV1100_BYPASS_COUNTER_MASK  0x020000L   // 0: default
                                                // 1: the selected counter
                                                //    clock source signal is
                                                //    bypassed to EXTSHUTTER
#define MV1100_CAMERA_DRIVE_OFFSET  18
#define MV1100_CAMERA_DRIVE_MASK    0x040000L   // 0: disable clock buffer
                                                // 1: enable clock buffer
#define MV1100_TIMING_POL_OFFSET    21
#define MV1100_TIMING_POL_MASK      0xE00000L   // B5: LDV/inv. LDV
                                                // B6: FDV/inv. FDV
                                                // B7: PCLK/inv. PCLK

#define MV1100_LDV_POL_OFFSET	    21		// LDV/inv. LDV
#define MV1100_LDV_POL_MASK	    (1<<21)

#define MV1100_FDV_POL_OFFSET	    22		// FDV/inv. FDV
#define MV1100_FDV_POL_MASK	    (1<<22)

#define MV1100_PCLK_POL_OFFSET	    23		// PCLK/inv. PCLK 
#define MV1100_PCLK_POL_MASK	    (1<<23)

#define MASTERMEM_PAGES (1024*1024/PAGE_SIZE)
#define NUM_TLISTS (2)

struct MV1_TransferList_s;
typedef struct MV1000 {
	
	u_char revision;
	u_char irq;
	volatile u_long iomem;	  // virtual address of io-mem
	u_long vvmem;		  // virtual address of Videomem
	u_long phys_mem; // CPU - untranslated Board Address 
	unsigned long  mastermem[MASTERMEM_PAGES];
	struct MV1_TransferList_s *tlist[NUM_TLISTS];
	int tlist_valid;
	int simulation;
	

//	Xilinx registers

	u32  h_start,h_end;
	u32  h_v_start;
	u32  h_v_end; 
	u32  v_start,v_end;
	u32  cur_line;
	u32  eq_remove;
	u32  grab_start_addr; 
	u32  misc_ctl;
	u32  lut_addr;
	u32  lut_data;
	u32  video_ctl;
	u32  lut_ctl;
	u16  vctl;
	u32  config_reg;

	u32  dac[8];

//   Filter SSI 32f8102 registers
	u32 filter_pdc;
		#define	SSI_PDC		2	// Power down control
	u32 freq_cutoff;
		#define SSI_DACF	3	// Cutoff freq. Controll Reg	
	u32 boost;
		#define SSI_DACB	11	// Boost Control Reg
	
//   PLL ICS1522 	
	u32 icsreg[7];

//      icsreg[4]:
		#define 	PDEN	(1<<6)
		#define		INT_VCO (1<<8)
		#define		CLK_SEL (1<<9)
//	icsreg[5]:
		#define FBK_SEL (1<<0)
		#define PDA	(3<<4)
		#define PDB	(3<<6)
		#define LD_LG	(1<<8)
		#define F_EN	(1<<9)
//	icsreg[6]:
	  	#define	OMUX1 (1<<3)
		#define OMUX2 (1<<4)
		#define OMUX3 (1<<5)
	 	#define OMUX4 (1<<6)
		#define EXTREF	(1<<10)

	u32 lm1882[19];
	u32  ext_vctl;

	MV1_GrabWindow curr_gw;
	u_long last_interrupt; // store the time of the last interrupt (jiffies)
	u_long frame_int_count; 
	u_long frame_count;	
	u_long bad_list_count;
	u_long transfer_end_count;
	u32 mem_mask;
//	u_long luts_private;
	u_long aq_frame;
	u_long do_transfer;
	int rest_time;
	int i_time;
	char snap;
	char snap_flag;

	MV1_Event event_queue[MV1_EVENTQUEUE_SIZE]; 
	u_long event_tab[EVENT_TAB_SIZE];
	u_long    event_queue_wp;  

	struct fasync_struct *fasync;
	wait_queue_head_t event_wait;
	wait_queue_head_t frame_end_wait;
	wait_queue_head_t transfer_end_wait;

	struct timer_list  watchdog_timer; 
	int  watchdog_timer_busy; 

	void (*frame_end_handler)(MV1_GrabWindow *gw,void *aqdata);
	void *aqdata;

} MV1000;
#define H_START(mv1) ((mv1->h_v_start>>14)&(0xffc))
#define H_END(mv1) ((mv1->h_v_end>>14)&(0xffc))

#endif // MV1REGS
